.app.koboldworks.data-inspector {
	min-width: 520px;
	min-height: 380px;

	> .window-content {
		overflow: hidden;
	}

	form {
		height: 100%;
		display: flex;
		gap: 3px;
		flex-direction: column;

		> .header {
			display: grid;
			grid-template-columns: 3fr minmax(min-content, 1fr);
			grid-template-rows: min-content;
			gap: 3px;

			.main {
				display: grid;
				grid-template-columns: min-content auto;
				//grid-template-rows: min-content;
				gap: 3px;
				align-items: center;
				height: min-content;
				flex: 1;

				label {
					display: contents;
				}
			}

			.path-box,
			.search-box {
				display: flex;
				gap: 3px;
				flex: 0;
				align-items: center;
			}

			.settings {
				display: flex;
				flex-direction: column;
				flex: 0;
				gap: 3px;
				align-items: center;

				label {
					display: flex;
					flex-flow: row nowrap;
					gap: 0.3rem;
					align-items: center;
				}

				> h4 {
					grid-column: span 2;
					font-variant: small-caps;
					margin: 0;
					text-align: center;
				}

				input[type='checkbox'] {
					margin: 0 5px;
					height: 16px;
					width: 16px;
				}

				select {
					line-height: 1;
					height: unset;
					width: min-content;
				}

				input[type='range'] {
				}
			}

			.main,
			.settings {
				border: 1px solid #6a594e5c;
				border-radius: 5px;
				padding: 3px;
				background-color: #897a701c;
				height: 100%;
			}
		}

		> .type {
			display: flex;
			white-space: nowrap;

			label {
				flex: 1;
			}
			.value {
				flex: 3;
				font-weight: bold;
			}
			gap: 0.25em;
		}

		input::placeholder {
			opacity: 0.6;
		}

		.hint {
			flex: 0;
		}

		> .data {
			height: 100%;
			overflow-y: scroll;

			/*
			display: grid;
			grid-template-columns: 1fr 1fr;
			grid-template-rows: min-content;
			gap: 1px;
			*/

			.warning {
				text-align: center;
			}

			&.derived,
			&.rolldata {
				[data-path]:not(.in-source) {
					.key {
						color: var(--data-inspector-entry-not-in-source);
					}
				}
			}

			&.source {
				[data-path]:not(.in-rolldata) {
					.key {
						color: var(--data-inspector-entry-not-in-rolldata);
					}
				}
			}

			.data-pools {
				.present {
				}

				.absent {
					//visibility: hidden;

					&.temporary,
					&.source {
						color: #c30808;
					}
				}
			}

			&.derived .data-pools .derived,
			&.source .data-pools .source,
			&.rolldata .data-pools .rolldata {
				//visibility: hidden;
			}
		}

		> .headers {
			display: flex;
			overflow-y: scroll;
			line-height: 1.5em;
			align-items: center;
			height: 2.5em;
			//font-weight: bold;
			background-color: var(--data-inspector-header-background);
			color: var(--data-inspector-header-font);

			.key {
				padding-left: 1.7em;
			}
		}

		> .data,
		> .headers {
			.key {
				flex: 1 6em;
			}

			.value {
				flex: 0 20em;
			}

			.data-pools {
				display: inline-flex;
				flex: 0 4em;
				gap: 1px;
				justify-content: center;

				.pool {
					flex: 0 1em;
					text-align: center;
				}
			}
		}

		ul {
			border: 1px solid #584a3f29;
			border-right: none;
			border-top: none;
			border-bottom-left-radius: 0.7em;

			flex: 1 100%;
			//display: contents;
		}

		> ul {
			border: none;
			border-right: 1px solid #584a3f26;
		}

		ul > li:nth-child(2n + 1) {
			background-color: rgba(0, 0, 0, 0.03);
		}

		ul > li:nth-child(2n + 0) {
			background-color: transparent;
		}

		ul > li.data-element.not-in-temporary .key {
			text-shadow: 0 0 3px var(--data-inspector-entry-nondefault-data);
		}

		ul {
			margin: 0;
			padding: 0;
			//padding-left: 0.7em;
			list-style: none;

			> li {
				padding-left: 0.7em;
			}

			.note {
				padding-left: 2em;
				font-size: 9pt;
				flex: 0;
			}

			.details {
				display: flex;
				flex-direction: row;
				justify-content: space-between;

				.extended-value {
					display: flex;
					flex-direction: row;
					flex-wrap: wrap;
				}

				.value-details {
					flex: 1 100%;
				}

				.value,
				.extended-value {
					flex: 0 20em;
				}

				.value {
					flex: 0 20em;
					white-space: nowrap;
					overflow: hidden;
					text-overflow: ellipsis;
					max-width: 20em;

					&.big {
						//flex: 1 100%;
						//font-size: 9pt;
						//padding-left: 2em;
						//white-space: normal;
						//white-space: break-spaces;
					}

					&.container {
						font-style: italic;
						opacity: 0.6;
					}

					&.function {
						font-style: italic;
						color: var(--data-inspector-entry-type-function);
					}

					&.string {
						&::after,
						&::before {
							content: '"';
							opacity: 0.4;
							color: unset;
						}

						color: var(--data-inspector-entry-type-string);
					}

					&.boolean {
						//font-style: italic;
						color: var(--data-inspector-entry-type-boolean);

						&.true:before {
							content: '🗹 ';
						}

						&.false:before {
							content: '☐ ';
						}
					}

					&.number {
						font-style: italic;
						color: var(--data-inspector-entry-type-number);
					}

					&.empty {
						//font-style: italic;
						color: var(--data-inspector-entry-type-empty);
					}

					&.recursion {
						font-style: italic;
						color: var(--data-inspector-entry-type-empty);
					}
				}

				h4 {
					flex: 0;
					margin: 0;
					padding: 0;
					line-height: 1.2;
				}

				&:hover {
					text-shadow: 0 0 5px var(--data-inspector-entry-hover-shadow);
					background-color: var(--data-inspector-entry-hover-background);
					box-shadow: 0 0 3px var(--data-inspector-entry-hover-boxshadow);
				}
			}

			li {
				display: flex;
				flex-wrap: wrap;
				justify-content: center;
				line-height: 1;
				position: relative;

				&:hover > ul.data-list {
					border-left: 1px solid var(--data-inspector-border-hover);
				}

				.details {
					flex: 1;
				}

				&:before {
					content: ' = ';
					white-space: pre;
					flex: 0 1em;
					opacity: 0.4;
				}

				&.expanded {
					&:before {
						content: ' - ';
						opacity: unset;
					}

					&:not(.empty) > .details {
						border-bottom: 1px solid var(--data-inspector-details-separator);
					}
				}

				&.empty {
					opacity: 0.6;

					.value.empty.string {
						&:before,
						&:after {
							opacity: unset; // Make empty strings less invisible
						}
					}
				}

				&.collapsed {
					&:before {
						content: ' + ';
						opacity: unset;
					}

					ul {
						display: none;
					}
				}

				&.document,
				&.function,
				&.getter {
					&:before {
						content: '~ ';
					}
				}

				&.getter {
					.value {
						&:hover {
							color: black;
							text-shadow: 0 0 15px red;
						}
					}
				}

				&[data-path]:hover {
					opacity: unset;
				}

				&[data-match-quality='mismatch'] {
					//background-color: gray;
				}

				&[data-match-quality='good'] {
					background-color: var(--data-inspector-search-good-match);
				}

				&[data-match-quality='bad'] {
					//background-color: #ff450014;
					&.value {
						display: none;
					}
				}

				&[data-match-quality='decent'] {
					background-color: var(--data-inspector-search-decent-match);
				}

				&.hide {
					display: none;
				}

				&.data-element.selected {
					background-color: var(--data-inspector-selected);
				}

				.value[data-id] {
					&:hover {
						color: black;
						opacity: unset;
					}
				}
			}
		}

		footer {
			display: flex;
			flex-flow: row;
			gap: 3px;

			> .footnote {
				display: flex;
				flex-flow: row nowrap;

				> label,
				> span {
					padding: 1px 3px;
				}
			}
		}
	}
}
